package com.prank.simulator.sounds.actfrag;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.util.Log;
import android.view.View;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.ContextCompat;

import com.bumptech.glide.Glide;
import com.prank.simulator.sounds.R;
import com.prank.simulator.sounds.data.ChildData;
import com.prank.simulator.sounds.databinding.ActPlaySoundsBinding;
import com.prank.simulator.sounds.dialog.PopupTimer;
import com.prank.simulator.sounds.helper.Db;
import com.prank.simulator.sounds.helper.Static;
import com.prank.simulator.sounds.helper.Utils;
import com.prank.simulator.sounds.listener.OnClickTimer;

import java.io.IOException;

public class PlayActivity extends AppCompatActivity implements View.OnClickListener, OnClickTimer {

    private ActPlaySoundsBinding playBinding;

    private ChildData childData;
    private PopupTimer popupTimer;

    private MediaPlayer mediaPlayer;
    private BroadcastReceiver volumeReceiver;
    private CountDownTimer countDownTimer;
    private int color;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        playBinding = ActPlaySoundsBinding.inflate(getLayoutInflater());
        setContentView(playBinding.getRoot());
        Utils.setStatusBarTextColor(this, true);
        childData = (ChildData) getIntent().getSerializableExtra(Static.KEY_PLAY_DATA);
        color = getIntent().getIntExtra(Static.KEY_PLAY_COLOR_POS, 0);

        playBinding.frameIm.setBackground(ContextCompat.getDrawable(this, Static.bgs[color]));
        initAudio();
        String covert = childData.getCovert();
        if (covert != null && !covert.isEmpty()) {
            Glide.with(this).load(covert)
                    .placeholder(R.drawable.tab_home0)
                    .into(playBinding.image);
        } else {
            Glide.with(this).load(R.drawable.im_import_audio)
                    .placeholder(R.drawable.tab_home0)
                    .into(playBinding.image);
        }
        playBinding.name.setText(childData.getName());
        playBinding.back.setOnClickListener(this);
        playBinding.linearPlay.setOnClickListener(this);
        playBinding.imLike.setOnClickListener(this);
        playBinding.imLoop.setOnClickListener(this);
        playBinding.imTimer.setOnClickListener(this);

        Utils.setVolume(this, playBinding.seekbar);

        initLike();
        volumeReceiver();

    }

    private void stopCountDown() {
        Log.d("------", "------stopCountDown");
        if (countDownTimer != null) {
            countDownTimer.cancel();
        }
    }

    private void startCountDown(long time) {
        stopCountDown();
        countDownTimer = new CountDownTimer(time, 1000) {
            @Override
            public void onTick(long millisUntilFinished) {
                Log.d("------", "------millisUntilFinished=" + millisUntilFinished);
            }

            @Override
            public void onFinish() {
                Log.d("------", "------onFinish");
                popupTimer.setOffSelected();
                if (!mediaPlayer.isPlaying()) {
                    playBinding.btnPlay.setSelected(true);
                    mediaPlayer.start();
                }
            }
        };
        countDownTimer.start();
    }

    private void volumeReceiver() {
        volumeReceiver = new BroadcastReceiver() {
            @Override
            public void onReceive(Context context, Intent intent) {
                if (intent.getAction().equals("android.media.VOLUME_CHANGED_ACTION")) {
                    AudioManager audioManager = (AudioManager) context.getSystemService(Context.AUDIO_SERVICE);
                    int currentVolume = audioManager.getStreamVolume(AudioManager.STREAM_MUSIC);
                    if (playBinding.seekbar.getProgress() != currentVolume) {
                        playBinding.seekbar.setProgress(currentVolume);
                    }

                }
            }
        };
        IntentFilter filter = new IntentFilter("android.media.VOLUME_CHANGED_ACTION");
        registerReceiver(volumeReceiver, filter);
    }

    private void initLike() {
        boolean b = Db.checkLike(childData);
        playBinding.imLike.setSelected(b);


    }

    private void initAudio() {
        showPlayBtn(false);
        mediaPlayer = new MediaPlayer();
        try {
            mediaPlayer.reset();
            mediaPlayer.setDataSource(childData.getAudioUrl());
            mediaPlayer.prepareAsync();
            mediaPlayer.setOnPreparedListener(new MediaPlayer.OnPreparedListener() {
                @Override
                public void onPrepared(MediaPlayer mp) {
                    showPlayBtn(true);
                }
            });

            mediaPlayer.setOnCompletionListener(new MediaPlayer.OnCompletionListener() {
                @Override
                public void onCompletion(MediaPlayer mp) {
                    playBinding.btnPlay.setSelected(false);
                }
            });
        } catch (IOException ioException) {
            showPlayBtn(true);
            Toast.makeText(this, "----------prepare fail", Toast.LENGTH_SHORT).show();
        }
    }

    private void showPlayBtn(boolean showBtn) {
        if (showBtn) {
            playBinding.linearPlay.setVisibility(View.VISIBLE);
            playBinding.playLoading.setVisibility(View.GONE);
        } else {
            playBinding.linearPlay.setVisibility(View.GONE);
            playBinding.playLoading.setVisibility(View.VISIBLE);
        }

    }


    @Override
    public void onClick(View v) {
        if (v.equals(playBinding.back)) {
            finish();
        } else if (v.equals(playBinding.linearPlay)) {
            boolean selected = playBinding.btnPlay.isSelected();
            if (selected) {
                if (mediaPlayer.isPlaying()) {
                    mediaPlayer.pause();
                }
            } else {
                if (!mediaPlayer.isPlaying()) {
                    mediaPlayer.start();
                }
            }
            playBinding.btnPlay.setSelected(!selected);

        } else if (v.equals(playBinding.imLike)) {
            playBinding.imLike.setSelected(!playBinding.imLike.isSelected());
            boolean selected = playBinding.imLike.isSelected();
            if (selected) {
                Db.addLike(childData);
            } else {
                Db.removeLike(childData);
            }
        } else if (v.equals(playBinding.imLoop)) {
            playBinding.imLoop.setSelected(!playBinding.imLoop.isSelected());
            mediaPlayer.setLooping(playBinding.imLoop.isSelected());
        } else if (v.equals(playBinding.imTimer)) {
            if (popupTimer == null) {
                popupTimer = new PopupTimer(PlayActivity.this, this);
            }
            popupTimer.showTop(playBinding.imTimer);
        }

    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (mediaPlayer.isPlaying()) {
            mediaPlayer.stop();
        }
        mediaPlayer.release();
        mediaPlayer = null;
        stopCountDown();
    }

    @Override
    public void onClickTimerListener(long time) {
        popupTimer.hide();
        if (time == -1) {
            stopCountDown();
        } else {
            startCountDown(time);
        }

    }
}